#include <iostream>
#include <type_traits>

using namespace std;

template <typename T, class = void_t<>>
struct m_preinkrement : false_type {};

template<class T>
struct m_preinkrement<T, void_t<decltype(++declval<T&>())> >
	: true_type {};

template<class T>
constexpr bool m_preinkrement_v = m_preinkrement<T>::value;

class Numero1
{
	int n;
public:
	Numero1(int n) : n(n) {}
	Numero1& operator++() { ++n; return *this; }
};

class Numero2
{
	int n;
public:
	Numero2(int n) : n(n) {}
	Numero2 operator++(int) { ++n; return *this; }
};

class Numero3 {};

Numero3& operator++(Numero3& n) { return n; }

int main()
{
	cout << m_preinkrement_v<Numero1> << endl;
	cout << m_preinkrement_v<Numero2> << endl;
	cout << m_preinkrement_v<Numero3> << endl;
	cout << m_preinkrement_v<int> << endl;
}