template<class T>
auto Max(T x)
{
	return x;
}

template<class T1, class ...Typy>
auto Max(T1 x, Typy ... param)
{
	auto pom = Max(param...);
	return pom > x ? pom : x;
}

template<class T1, class ... Typy>
auto Max1(T1 x, Typy...param)
{
	if constexpr (sizeof...(param) == 0)
	{
		return x;
	}
	else
	{
		auto pom = Max1(param...);
		return pom > x ? pom : x;
	}
}

auto Max2(auto x, auto ... param)
{
	if constexpr (sizeof...(param) == 0)
	{
		return x;
	}
	else
	{
		auto pom = Max2(param...);
		return pom > x ? pom : x;
	}
}

int main()
{
	auto y = Max(1, 1.5, 0);
	auto z = Max1(2, 0.1, -55);
	auto w = Max2(1, 11.1, -6.6, 55);
}